#include <Adafruit_NeoPixel.h>

#define PIN 1

Adafruit_NeoPixel strip = Adafruit_NeoPixel(7, 0, NEO_GRB + NEO_KHZ800);

uint32_t color1 = strip.Color(236, 79, 100); //hier zijn wat kleuren gedefineerd in RGB code
uint32_t color2 = strip.Color(246, 216, 180);
uint32_t color3 = strip.Color(174, 113, 208); 
uint32_t color4 = strip.Color(182, 31, 40); 
uint32_t color5 = strip.Color(91, 44, 86); 

int sensorPin = 1;           // het nummer van de pin waar de var. weerstand aangesloten is
int colorValue = 0;          // een variabele die we gebruiken om van kleur te veranderen
int helderheid = 1;          // kun je van 0 tot 100 instellen

const float VCC = 3.3;       // Uitgangsspanning
const float R_DIV = 47500.0; // waarde van vaste weerstand in Ohm

// Code uploaden en probeer daarna de waardes wat aan te passen
// om beter te meten hoeveel de weerstand buigt
float STRAIGHT_RESISTANCE = 37300.0; // resistance when straight
float BEND_RESISTANCE = 90000.0;     // resistance at 90 deg
//deze waardes gaan bijhouden wat de werkelijke kleinste
//en grootste weerstand is om zo het systeem zelf te kunnen ijken
int highestR = 0;
int lowestR = 1000000000000;

void setup() {
  // Set internal pullup resistor for sensor pin (analog 1 is digital 2)
  pinMode(2, INPUT_PULLUP); 
  strip.begin();
  strip.setBrightness(helderheid); //adjust brightness here
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {
  // read the value from the sensor:
  //sensorValue = analogRead(sensorPin);
  int flexADC = analogRead(sensorPin);
  float flexV = flexADC * VCC / 1023.0;
  float flexR = R_DIV * (VCC / flexV - 1.0);
  int colorValue = map(flexR, STRAIGHT_RESISTANCE, BEND_RESISTANCE, 0, 100);//map is een functie die waardes omzet naar een andere schaal

//stukje code hieronder moet, terwijl je bezig bent met je vinger buigen, 
//er achter te komen wat de echte maximale en minimale weerstand is
  if(flexR<lowestR){
    lowestR = flexR;
    STRAIGHT_RESISTANCE=flexR;
  }
  if(flexR>highestR){
    highestR = flexR;
    BEND_RESISTANCE=flexR;
  }
  animatie(colorValue);                 
}


//aparte functie die verschillende kleuren laat zien
//je kunt hier animaties in definiren.
void animatie(int colorValue){

  int pauze =  int(255 - colorValue);//iets om mee te spelen
  helderheid = int(100 - colorValue);//dit ook
  strip.setBrightness(helderheid);
  
  strip.setPixelColor(1, color1); 
  strip.setPixelColor(2, color1); 
  strip.setPixelColor(3, color1); 
  strip.setPixelColor(4, color1); 
  strip.setPixelColor(5, color1); 
  strip.setPixelColor(6, color1); 
  strip.setPixelColor(0, color2); //pixel 0 is de middelste pixel
  
  strip.show();
  delay(pauze);
    
  strip.setPixelColor(1, color2); 
  strip.setPixelColor(2, color2); 
  strip.setPixelColor(3, color2); 
  strip.setPixelColor(4, color2); 
  strip.setPixelColor(5, color2); 
  strip.setPixelColor(6, color2); 
  strip.setPixelColor(0, color3); 
  
  strip.show();
  delay(pauze);
  
  strip.setPixelColor(1, color3); 
  strip.setPixelColor(2, color3); 
  strip.setPixelColor(3, color3);
  strip.setPixelColor(4, color3); 
  strip.setPixelColor(5, color3); 
  strip.setPixelColor(6, color3); 
  strip.setPixelColor(0, color4); 
  
  strip.show();
  delay(pauze);
  
  strip.setPixelColor(1, color4); 
  strip.setPixelColor(2, color4); 
  strip.setPixelColor(3, color4); 
  strip.setPixelColor(4, color4); 
  strip.setPixelColor(5, color4); 
  strip.setPixelColor(6, color4); 
  strip.setPixelColor(0, color5); 
  
  strip.show();
  delay(pauze);
  
  strip.setPixelColor(1, color5); 
  strip.setPixelColor(2, color5); 
  strip.setPixelColor(3, color5);
  strip.setPixelColor(4, color5); 
  strip.setPixelColor(5, color5); 
  strip.setPixelColor(6, color5); 
  strip.setPixelColor(0, color1); 
  
  strip.show();
  delay(pauze);
  


}
